# Changelog

All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](http://keepachangelog.com/en/1.0.0/)
and this project adheres to [Semantic Versioning](http://semver.org/spec/v2.0.0.html).

## [Unreleased]

## [2.3.1] _(06/09/2018)_

### Changed

- `page()` do not push anymore

## [2.3.0] _(06/09/2018)_

### Changed

- query-string for old browser support

### Removed

- remove aggregate-errors

## [2.2.0] _(05/09/2018)_

### Added

- add `pageAttribute`
- add `destroy()` method

### Changed

- improve UMD build

## [2.1.3] _(24/08/2018)_

### Changed

- test UMD build

## [2.1.2] _(23/08/2018)_

### Added

- get url hash

## [2.1.1] _(23/08/2018)_

### Added

- get url param

## [2.0.7] _(23/08/2018)_

### Changed

- naming harmonisation between page namespace and component slug

## [2.0.6] _(23/08/2018)_

### Fixed

- wrong namespace assignation mechanism

## [2.0.5] _(23/08/2018)_

### Added

- optional namespace for override

### Changed

- disable open bundle analyzer report

## [2.0.4] _(22/08/2018)_

### Removed

- Heavy deps (from config)
- Snippet ([NOTES.md](NOTES.md))

## [2.0.3] _(19/08/2018)_

### Removed

- Heavy deps

## [2.0.2] _(19/08/2018)_

### Changed

- Errors handling

## [2.0.1] _(12/08/2018)_

### Added

- Data example
- Missing deps

### Fixed

- Coverage badge
- Typos

## [2.0.0] _(11/08/2018)_

- :tada: initial commit

> Version 2.0 because it has nothing to do with previous version…

---

## Memo

### Guiding Principles

- Changelogs are for humans, not machines.
- There should be an entry for every single version.
- The same types of changes should be grouped.
- Versions and sections should be linkable.
- The latest version comes first.
- The release date of each versions is displayed.
- Mention whether you follow Semantic Versioning.

### Types of changes

- `Added` for new features.
- `Changed` for changes in existing functionality.
- `Deprecated` for soon-to-be removed features.
- `Removed` for now removed features.
- `Fixed` for any bug fixes.
- `Security` in case of vulnerabilities.
