"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.Snitchy = void 0;

var _trim = _interopRequireDefault(require("trim"));

var _queryString = _interopRequireDefault(require("query-string"));

var _utils = require("./utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var instance;

var Snitchy =
/*#__PURE__*/
function () {
  _createClass(Snitchy, null, [{
    key: "start",
    value: function start(options) {
      instance = instance || new Snitchy(options);
      return instance;
    }
  }, {
    key: "destroy",
    value: function destroy() {
      instance = null;
    }
  }]);

  function Snitchy() {
    var _this = this;

    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {
      pageAttribute: 'data-snitchy-page'
    };

    _classCallCheck(this, Snitchy);

    this._debug = false;
    this._pageAttribute = options.pageAttribute;
    this._prefixes = {
      attr: {
        fn: function fn(key) {
          var htmlKey = (0, _utils.kebabCase)(key);
          return document.documentElement.getAttribute(htmlKey) || (0, _utils.qs)("[".concat(htmlKey, "]"), document.documentElement).getAttribute(htmlKey);
        },
        error: function error(key) {
          return "Unable to find \"".concat((0, _utils.kebabCase)(key), "\" attribute.");
        }
      },
      tag: {
        fn: function fn(key) {
          return (0, _trim.default)((0, _utils.qs)(key, document.documentElement).textContent);
        },
        error: function error(key) {
          return "Unable to find \"".concat(key, "\" element.");
        }
      },
      this: {
        fn: function fn(key) {
          return _this.scope[key];
        },
        error: function error(key) {
          return "Unable to get \"this.".concat(key, "\". No scope found.");
        }
      },
      url: {
        fn: function fn(key) {
          var _window = window,
              location = _window.location;

          if (key) {
            var _Snitchy$parseValue = Snitchy.parseValue(key),
                _Snitchy$parseValue2 = _slicedToArray(_Snitchy$parseValue, 2),
                type = _Snitchy$parseValue2[0],
                value = _Snitchy$parseValue2[1];

            var parsed = _queryString.default.parse(location.search);

            if (type === 'hash') {
              return location.hash.replace(/^#/, '');
            }

            if (type !== 'param' || !value) {
              throw new Error();
            }

            return parsed[value] || '';
          }

          return window.location.href;
        },
        error: function error(key) {
          var _Snitchy$parseValue3 = Snitchy.parseValue(key),
              _Snitchy$parseValue4 = _slicedToArray(_Snitchy$parseValue3, 2),
              value = _Snitchy$parseValue4[1];

          return "No keyword \"param\" or \"".concat(value, "\" found in \"window.location.search\"");
        }
      },
      val: {
        fn: function fn(key, values) {
          return values[key];
        },
        error: function error(key) {
          return "Unable to get \"values.".concat(key, "\". No values found.");
        }
      }
    };
  }

  _createClass(Snitchy, [{
    key: "addPrefix",
    value: function addPrefix(name, options) {
      if (this.prefixes[name]) {
        (0, _utils.displayWarnings)("Prefix \"".concat(name, " already exists! You can remove it\u2026"));
        return;
      }

      Object.keys(options).forEach(function (key) {
        // No additional properties
        if (!key.match(/fn|error/)) {
          (0, _utils.displayErrors)("Invalid option \"".concat(key, "\" [no additional data]"));
        } // Should be a function


        if (key.match(/fn|error/) && typeof options[key] !== 'function') {
          (0, _utils.displayErrors)("Invalid option \"".concat(key, "\" [should be a function]"));
        }
      });
      this._prefixes[name] = options;
    }
  }, {
    key: "removePrefix",
    value: function removePrefix(name) {
      if (this.prefixes[name]) {
        delete this._prefixes[name];
        return;
      }

      (0, _utils.displayWarnings)("Prefix \"".concat(name, " unknown!"));
    }
  }, {
    key: "load",

    /**
     * Load variables data
     *
     * @param {object} variables to load
     * @returns {undefined}
     * @memberof Snitchy
     */
    value: function load(variables) {
      Object.keys(variables).forEach(function (key) {
        // No additional properties
        if (!key.match(/pages|components/)) {
          (0, _utils.displayErrors)("Invalid option \"".concat(key, "\" [no additional data]"));
        } // Should be an object


        if (key.match(/pages|components/) && _typeof(variables[key]) !== 'object') {
          (0, _utils.displayErrors)("Invalid option \"".concat(key, "\" [should be an object]"));
        }
      });

      try {
        (0, _utils.validate)(variables);
        this._variables = variables;
      } catch (error) {
        (0, _utils.displayErrors)('Invalid variables data !', error);
      }
    }
    /**
     * Check if variables are there
     *
     * @param {string} [from='variables'] name of the method trying to use this.variables
     * @returns {boolean} loaded or not…
     * @memberof Snitchy
     */

  }, {
    key: "isLoaded",
    value: function isLoaded() {
      var from = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'variables';

      // eslint-disable-line consistent-return
      try {
        return this._variables;
      } catch (err) {
        (0, _utils.displayErrors)("No \"variables\" found [snitchy.".concat(from, "]. Are they loaded?"), err);
      }
    }
    /**
     * Push "page" analytics.
     *
     * @param {string | array} layer main layer(s)
     * @param {object} values optional values from "caller"
     * @param {*} scope optional scope from "caller"
     * @param {string} ns optional namespace for override
     * @returns {null | object} pushed data
     * @memberof Snitchy
     */

  }, {
    key: "page",
    value: function page(layer, values, scope, ns) {
      var _this2 = this;

      if (!this.isLoaded('page()')) {
        return null;
      }

      if (typeof layer !== 'string' && !Array.isArray(layer)) {
        (0, _utils.displayErrors)('Expected argument "layer" to be of type `string` or `array`');
      } // Get array of layers


      var layers = Array.isArray(layer) ? layer : [layer];
      this.values = values;
      this.scope = scope; // Get the current namespace

      var namespace;

      if (ns) {
        namespace = ns;
      } else if ((0, _utils.qs)("[".concat(this._pageAttribute, "]"), document.documentElement)) {
        // eslint-disable-next-line prefer-destructuring
        namespace = (0, _utils.qs)("[".concat(this._pageAttribute, "]"), document.documentElement).getAttribute(this._pageAttribute);
      } else {
        namespace = null;
      } // Prepare data


      var data = {}; // Get global (all) and custom (namespace) data

      layers.forEach(function (layer) {
        var global = _this2.variables.pages.all && _this2.variables.pages.all[layer] ? _this2.getData(_this2.variables.pages.all[layer]) : {};
        var custom = _this2.variables.pages[namespace] && _this2.variables.pages[namespace][layer] ? _this2.getData(_this2.variables.pages[namespace][layer]) : {};
        data[layer] = _objectSpread({}, global, custom);

        if (Object.keys(data[layer]).length === 0) {
          (0, _utils.displayWarnings)("No data found for \"".concat(layer, "\" layer on \"").concat(namespace || 'all', "\" page."));
          delete data[layer];
        }
      }); // Do not push empty data…

      if (Object.keys(data).length === 0) {
        return null;
      }

      dataLayer = [data]; // eslint-disable-line no-global-assign

      if (this.debug) {
        console.info('📈 PUSH!', data);

        if (console.table) {
          console.table(data);
        }
      }

      return data; // DEV
      // return this.push(data);
    }
    /**
     * Push "component" analytics.
     *
     * @param {string} slug component slug
     * @param {object} values optional values from "caller"
     * @param {*} scope optional scope from "caller"
     * @param {string} [trigger = false] optional trigger from "caller"
     * @returns {undefined}
     * @memberof Snitchy
     */

  }, {
    key: "component",
    value: function component(slug, values, scope, trigger) {
      var _this3 = this;

      if (!this.isLoaded('component()')) {
        return null;
      }

      if (typeof slug !== 'string') {
        (0, _utils.displayErrors)('Expected argument "slug" to be of type `string`');
      }

      this.values = values;
      this.scope = scope;
      var variables = this.variables.components[slug];

      if (!variables) {
        return null;
      }

      var pushed = [];
      Object.keys(variables) // Filter if optional trigger
      .filter(function (description) {
        return trigger ? variables[description].trigger === trigger : true;
      }).forEach(function (description) {
        // Prepare data
        var variable = variables[description];

        var data = _this3.getData(variable);

        delete data.trigger;
        pushed.push(data);

        _this3.push(data);
      });
      return pushed;
    }
    /**
     * Push data to dataLayer
     *
     * @param {object} data data to push
     * @returns {undefined}
     * @memberof Snitchy
     */

  }, {
    key: "push",
    value: function push(data) {
      if (this.debug) {
        console.info('📈 PUSH!', data);

        if (console.table) {
          console.table(data);
        }
      } else {
        try {
          dataLayer.push(data);
        } catch (err) {
          (0, _utils.displayErrors)('No "dataLayer" found. Check if GTM is correctly configured.', err);
        }
      }

      return data;
    }
    /**
     * Get data from variables
     *
     * @param {object} obj variables
     * @returns {object} data
     * @memberof Snitchy
     */

  }, {
    key: "getData",
    value: function getData(obj) {
      var _this4 = this;

      if (!obj) {
        return {};
      } // Get values


      return Object.keys(obj).reduce(function (data, k) {
        data[k] = Snitchy.isDynamicValue(obj[k]) ? _this4.getValue(obj[k]) : obj[k];
        return data;
      }, {});
    }
    /**
     * Get a dynamic value
     *
     * @param {string} value dynamic string to convert in real value
     * @returns {* | undefined} calculated value
     * @memberof Snitchy
     */

  }, {
    key: "getValue",
    value: function getValue(value) {
      var data;

      var _Snitchy$parseValue5 = Snitchy.parseValue(value),
          _Snitchy$parseValue6 = _slicedToArray(_Snitchy$parseValue5, 2),
          type = _Snitchy$parseValue6[0],
          key = _Snitchy$parseValue6[1];

      try {
        var hasPrefix = this.prefixes[type].fn; // eslint-disable-line no-unused-vars
      } catch (err) {
        (0, _utils.displayErrors)("Unable to find valid \"".concat(type, "\" prefix."), err);
      } // Try "fn" or throw "error"


      try {
        data = this.prefixes[type].fn(key, this.values, this.scope);
      } catch (err) {
        if (this.prefixes[type].error) {
          // Allow "fn" to throw "custom" error…
          (0, _utils.displayErrors)([this.prefixes[type].error(key), err]);
        } else {
          (0, _utils.displayErrors)("Something went wrong with \"".concat(key, "\" (No error message for \"").concat(type, "\")."), err);
        }
      } // "fn" did not return error but undefined


      if (data === undefined) {
        var desc = 'undefined';

        if (type === 'this') {
          desc = 'property';
        }

        if (type === 'val') {
          desc = 'value';
        }

        (0, _utils.displayErrors)("Unable to find \"".concat((0, _utils.kebabCase)(key), "\" ").concat(desc, "."));
      }

      return data;
    }
    /**
     * Check if a value is "dynamic" and should be parsed.
     * Dynamic values start with a '$'.
     *
     * @static
     * @param {string} value value to check
     * @returns {boolean} is dynamic
     * @memberof Snitchy
     */

  }, {
    key: "debug",
    set: function set(status) {
      this._debug = status;
    },
    get: function get() {
      return this._debug;
    }
  }, {
    key: "prefixes",
    get: function get() {
      return this._prefixes;
    }
  }, {
    key: "variables",
    get: function get() {
      return this._variables || this.isLoaded();
    }
  }], [{
    key: "isDynamicValue",
    value: function isDynamicValue(value) {
      return value.match(/^\$/);
    }
    /**
     * Parse and format a dynamic value.
     *
     * @static
     * @param {string} value dynamic value $typeKeyToFindValue
     * @returns {[string, string]} type and key (format: keyToFindValue)
     * @memberof Snitchy
     */

  }, {
    key: "parseValue",
    value: function parseValue(value) {
      return value.split(/(?=[A-Z])/).reduce(function (acc, cur, i) {
        if (i === 0) {
          acc.push(cur.replace('$', ''));
        } else if (i === 1) {
          acc.push(cur.toLowerCase());
        } else {
          acc[1] += cur;
        }

        return acc;
      }, []);
    }
  }]);

  return Snitchy;
}();

exports.Snitchy = Snitchy;

var _default = Snitchy.start();

exports.default = _default;